/*
copyright 2010 Chris Glasier 
coding advice by Jim Foltz 
code check JSLint 24 September 2010
*/
/*global
config,nset,mset,noldDown,moldDown,coreDold,fList,fPrompts,fOptions,clearInterval,setInterval,document
*/

/*
core, ruby, mac and inter are reserved function/variable prefixes
core contains all common functions
*/

/* runs after vertical animation ends
noldDown + moldDown are in machine.js; coreDold here */

function coreDown2(prms){
	switch(prms[1]){
		case "nold"	: noldDown(prms); break;
		case "mold"	: moldDown(prms); break;
		case "dold"	: coreDold(prms); break;
	}
}

function easeQuadOut(t, b, c, d) {
    //noinspection AssignmentToFunctionParameterJS
    return -c * (t/=d)*(t-2) + b;
}

function linearTween(t, b, c, d) { 
	return c*t/d + b; 
}

// runs selected cell into middle with coreDown 
// moves names left with macSliderLeft

function coreAnimate(obj, elm, begin, end, duration, fps, sw, prms) {
	var change,interval,steps,i;
	change      = end-begin;
	interval    = Math.ceil(1000/fps);
	steps		= Math.ceil(duration/interval);
	if(obj.coreStop){
		clearInterval(obj.coreStop);
	}
	i = 0;
    obj.coreStop = setInterval(
	function() { 
		obj.last = easeQuadOut(i, begin, change, steps);
		obj.style[elm]  = obj.last + 'px'; 
		i+=1;
		if (i > steps){
			clearInterval(obj.coreStop);
			if(sw === 1){
				coreDown2(prms);
			}
		}
	} 
	,interval);
}

function coreDown(cell){
	var sldr,sName,sNo,p,a,cTop,sTop,st,dist,fin,cnt,elm,prms,spd,fps,sw; 
	sldr	= cell.parentNode;
	sName	= sldr.id.slice(0,4);
	sNo	= parseInt(sldr.id.slice(4),10);
	p = cell.className.charAt(0);
	for(a=0; a < sldr.childNodes.length; a+=1){
		sldr.childNodes[a].className = p+"bdr";
	}
	cell.className	= p + "bgc";
	cTop	= cell.offsetTop;
	sTop	= sldr.offsetTop;
	st		= Math.round(document.body.clientHeight/2);
	dist	= cTop + sTop - st;
	fin		= sTop - dist;
	elm		= "top";
	if(cTop + sTop === st){
		cnt = 1;
	}
	else{
		cnt = 0;
	}
	prms = [cell ,  sName , sNo , cnt , fin];
	spd = config.animate;	// milliseconds
	fps	= 20;				//frames/sec
	sw	= 1;				// activates coredown2
	coreAnimate(sldr, elm, sTop, fin, spd, fps, sw, prms);
}

function coreSliderHolder(c, dv, t){
	var o,cw;
	o = document.createElement("div");
	document.getElementById(dv).appendChild(o);
	o.id = dv + c; 
	cw = config.colwidth;
	o.style.left = cw * c + "px" ;
	o.style.top = t + "px";
	o.style.width = cw;
}	

function coreNsetSlider(list, c) {
	var sldr,k,n,ent,d,o,st,nt,cn,s; 
	sldr	= document.getElementById("nold" + c);
	sldr.innerHTML = "";
	k = [];
	for (n in list) {
		//alert(JSON.stringify(nset[list[n]]))
		if(nset[list[n]].hasOwnProperty("Name") || nset[list[n]].hasOwnProperty("Filter")){
			ent = [nset[list[n]].Name , list[n] , nset[list[n]].Filter];
			k.push(list[n]);
		}
	}
	for(d = 0; d < k.length; d+=1){
		o = document.createElement("div");
		sldr.appendChild(o);
		o.id = "n" + k[d];
		o.title = o.id;			//testing
		o.innerHTML = nset[k[d]].Name;
		st = config.stripetop;
		nt = config.nametrail;
		if(nset[k[d]].Type === "Set" || nset[k[d]].Type === "Scene"){
			p = "s";
		}
		else{
			p = "n";
		}
		if(o.offsetParent.offsetTop + o.offsetTop ===  st && c !== nt.length-1){
			cn = p + "bgc";
		}
		else{
			cn = p + "bdr";
		}
		o.className = cn;
		o.onmousedown = function() { coreDown(this , c , "nold"); };
		s = o.style;
		s.width = "100%";
		s.height = config.cellheight;
		if(nset[k[d]].Type === "Nset"){
			s.fontWeight = 900;
		}
		if(nset[k[d]].Filter){	
			s.textDecorationLineThrough = true;
		}
		else{
			s.textDecorationLineThrough = false;
		}
	}
}

function coreMenuSlider(c){
	var sldr,mt,k,a,o,s;
	sldr = document.getElementById("mold"+c);
	sldr.innerHTML = "";
	mt = config.menutrail;
	sldr.style.top = config.stripetop - mt[c][1] + "px";
	k = mset[mt[c][0]].Forelink;
	for(a = 0; a < k.length; a += 1){
		o = document.createElement("div");
		sldr.appendChild(o); 
		o.id = "m" + k[a];
		o.title = o.id;		//for testing
		o.innerHTML = mset[k[a]].Name;
		o.className = "mbdr";
		o.onmousedown = function() { coreDown(this , c , "mold" ); };
		s = o.style;
		s.width = "100%";
		s.height = config.cellheight;
	}
}

function coreDeviceSlider(c, list, caps){
	var sldr,a,o,s;
	sldr = document.getElementById("dold"+c);
	sldr.innerHTML = "";
	sldr.style.top = config.stripetop;
	for(a = 0; a < list.length; a += 1){
		o = document.createElement("div");
		sldr.appendChild(o); 
		//list[a] is singleton
		if(!list[a][0]){
			o.id		= list[a];
			o.innerHTML = list[a];
		}
		else{
		
		//list[a] is []; for displaying values in devices and using 
		//ids for function calls 
		
		o.id = list[a][0];
			o.innerHTML = list[a][1];
		}
	if(caps){
		o.innerHTML = o.innerHTML.toUpperCase();
	}
	o.title = o.id;		//for testing
	o.className = "dbdr";
	o.onmousedown = function() { coreDown(this , c , "dold" ); };
	s = o.style;
	s.width = "100%";
	s.height = config.cellheight;
	}
}

function coreInpboxHide(){
	document.getElementById("inpbox").style.display = "none";
}

//Slides the menu panel to show/hide underlying device menu(s)

function coreShutter(amt){
	var obj,start,fin;
	obj		= document.getElementById("mold");
	start	= parseInt(obj.style.left,10);
	fin		= (config.columns - amt) * config.colwidth;
	coreAnimate(obj , "left" , start, fin , 300, 20, 0 );
}

//device events

function coreDold0(prm){				//prm = cell, sliderName , sliderNo ,  cnt , fin 
	var cell,cTop,cnt,nt,node;
	cell		= prm[0];
	cTop		= cell.offsetTop;
	cnt			= prm[3];
	document.getElementById("dold1").innerHTML = "";
	coreShutter(1);
	nt		= config.nametrail;
	node	= nt[nt.length-1][0];
	fPrompts(cell,cnt,node);
}

function coreDold1(prm){
	var f,nt,st,cell,cnt,node; 
	f = config;
	nt		= f.nametrail;
	st		= f.stripetop;
	cell	= prm[0]; 
	cnt		= prm[3];
	node	= nt[nt.length-1][0];
	fOptions(cell,cnt,node);
}

function coreDold(prm){
	var k,a;
	coreInpboxHide();					//in case input/confirm aborted
	k = prm[0].parentNode.childNodes;
	for(a = 0; a < k.length; a += 1){
		k[a].className = "dbdr";
	}
	prm[0].className = "dbgc";
	if(prm[2] === 0){
		coreDold0(prm);
	}
	else{
		coreDold1(prm);
	}
}

//Uses length of nset to make unique number label

function coreLength(){
	var lgth, a;
	lgth = 0;
	for(a in nset){ 
		lgth += 1; 
	}
	return(lgth.toString());
}

function corePurge(){
	coll = document.body.childNodes
	for(a=0; a < coll.length; a += 1){
		if (coll[a].tagName ===	"SCRIPT" && coll[a].id === ""){
			document.body.removeChild(coll[a]); a -= 1;
		}
	}	
}